#include <stdio.h>
#include <stdlib.h>

/* Prototipos de las funciones a implementar en ensamblador en funcasm.asm */
extern void num_a_mod(unsigned long *vecnum, unsigned int *vecmod);
extern void prod_mod(unsigned int *op1m, unsigned int *op2m, unsigned int*resm);
extern void suma_mod(unsigned int *op1m, unsigned int *op2m, unsigned int*resm);

/* Prototipo de la funcin de conversion de modular a convencional, implementada en modanum.c */
extern void mod_a_num(unsigned int *vecmod, unsigned long *vecnum);

/* numero de ctes a usar en la repr. modular */
#define R (4)

/* ctes sin factores comunes de 16 bits m_i, cambiarlas por otras si se desea, pero deben estar definidas aqui */
unsigned int m[R] = {65535, 65534, 65533, 65531};


/* Variables para contener los operandos y resultados en las dos representaciones */
unsigned long op1[2];
unsigned long op2[2];
unsigned int op1m[R];
unsigned int op2m[R];
unsigned int resm[R];
unsigned long res[2];


void main(void){

/* se leen los operandos */

	printf("Introduzca el operando 1 en hexadecimal en dos partes de 32 bits c/u\n");
	printf("Parte Baja: ");
	scanf("%lx",&op1[0]);
	printf("\nParte Alta: ");
	scanf("%lx",&op1[1]);
	printf("\nIntroduzca el operando 2 en hexadecimal en dos partes de 32 bits c/u\n");
	printf("Parte Baja: ");
	scanf("%lx",&op2[0]);
	printf("\nParte Alta: ");
	scanf("%lx",&op2[1]);

/* Convertirlos a representacion modular */
	num_a_mod(op1, op1m);
	num_a_mod(op2, op2m);

/* realizar operacion, p.ej., producto */
	prod_mod(op1m, op2m, resm);

/* convertir el resultado a la rep. convencional */
	mod_a_num(resm, res);

/* imprimir el resultado */
	printf("El resultado del producto en 64 bits hex es %08lx%08lx\n", res[1], res[0]);

}